# 需求与“死锁”
> 某种意义上，“死锁”也是我当前面临的心理困境。

## 首先，因为有了需求
我自认非常之“贪心算法”，我的行动也基本上为了“主观的当下”服务：我想要做什么？我想做的事需要什么条件？有没有可能设法达成？

这样通过需求推导，针对性地采取措施（比如学某项技能、做物质准备），在我看来算是一种“需求导向”。尽管“实用主义”并非真理，但马哲也好，各种方法论也罢，或许正因它们如同预期那般发挥了作用，人们才广泛运用它们的吧。

所以，在需求的驱使下，我认识了很多英语单词，折腾起 Windows 的配置，上手 AE 瞎摆弄着频谱特效，然后是 PECMD 脚本、C#、Python……虽然，没人理解我为何钟情这些“有的没的”。

不得不承认，国人的一生非常地现实，客观的非生理需求（好比学生的学习应试需求）也是不得不直视的生活一部分。然鹅长期以来我都活得比较主观，社会的要求或者说“客观需求”并没有得到足够的重视，那么客观、社会现实层面上我无疑是比较失败的。

## 然后，需求催生动力
需求或许是学习最直接的原动力了吧，毕竟……是自己的欲求嘛。有人为了看懂番剧自学五十音，有人为了解放重复劳动学着写脚本写程序，也有人只是想上手玩玩什么——但那何尝不是一种需求，娱乐需求。

当然，正所谓“师者，传道受业解惑者也”，作为“徒”，学习或许也分两种途径：悟道与解惑。  
但……我所接触的早年的“红警 diy”对新人谈不上友好，有事没事“看教程”；现实当中我也无从问起，反倒更多地在为别人解惑——“你这么懂都不会，那我们这些不懂的更帮不了你了啊”。所以，面对如今热门的各种 AI，社恐的我还真的无所适从——要怎么斟酌语言提问呢？  
如此，好像只剩下“我自己明悟”这一条路了。或许我应该庆幸，自己借此学会当一个调试器——是 200 OK 还是 417 Expectation Failed，实地测测不就知道了。而除了各种课程、教程资源，实地测试以外，最重要的能力大抵就是信息检索能力吧，毕竟“伸手党”亦为早期互联网所不齿。

## 但，假如需求链太长了呢？
这个问题在考研备考的后期逐渐暴露出来，并且随着就业压力愈发凸显。

我所谓的“需求导向”，成也需求，败也需求。人是有惰性的，对于一件工具，一样技艺，若只凭需求去学习运用，便容易浅尝辄止，“需要做什么我便学了什么为止”。想要搓一个好看的频谱视频，便只折腾频谱；想要方便地处理红警的 ini 和 csf，便和键值对数据结构钻牛角尖。

这样的结果有二。其一，面对更高的需求时，一时间拿不出对等的“解”满足它。其一之后往往也是其二，一旦发现需求链过长，解决它需要付出很大的代价（尤其是时间），这时“需求导向”失灵，至今为了解决需求所做的一切全都归于虚无。

我 24 考研失利就在于此，哪怕最简单的数二，也难以理解“武神”如何省略的步骤，直接得出结果；然后发现是中学的芝士，却遗憾地发现连中学的知识点都不甚理解，就这样溯源到了初中。哪怕再给我一年，从初中重新学回来的收效也犹未可知。

此后忙前忙后，终于还是没能“跨”去计专，就那样毕业了。然鹅哪怕忽略掉各大单位“卡专业”的事实，我也顿觉自己只学了个皮毛，与人家的技术栈相去甚远。Native Programming？不不不，早就是 web 应用的时代了；什么？数据库都不认识？那还好意思去做程序员？

## 最终，形成了死锁
于是，我陷入了“虚无”，尽管我很清楚自己的状态并不正常、自己的思绪需要疏导，清楚自己“虚无”的症结——

::: center
有限的能力需要需求给养，然鹅莫得需求需要我解决，我也不再清楚“想做什么”；  
更高的需求需要能力支持，然鹅莫得能力去搭这把手，我也茫然不知“要怎么做”。
:::

豪德，两边都等不到对方，死锁就这么成了。

尽管写这篇小作文的当下我已试着找些新的方向和需求，但漫无目的地学，也不过是学个乐呵。有没有用嘛……谁知道呢？哪天真有用了或许也已经淡忘了吧。
